import { ApplicationCommandOptionData, ApplicationCommandOptionType, CommandInteraction } from "discord.js"
import { Battle, BattleState } from "../battle"
import { CBClient } from "../cbclient"
import { CHARACTERS } from "../characters"
import { Player } from "../models/player"
import { Unit } from "../models/unit"
import { createArgumentsObject, SlashCommand } from "./slash"

export class BattleTestCommand implements SlashCommand {
	name = 'battletest'
    description = 'shhh'
    permission = []
    ownerOnly = false
    guildOnly = false
    guildID = "739645806100873328" //for testing
    args: ApplicationCommandOptionData[] = []

	async execute(int: CommandInteraction) {
        const client = int.client as CBClient;
        const you = await client.findOrCreatePlayer(int.user.id);
        const units = (await Unit.findAll());
        const battle = new Battle(int.channel!, you, you, units.slice(0, 3) as [Unit, Unit, Unit], units.slice(3, 6) as [Unit, Unit, Unit]);

        await int.reply({
            content: 'gottem'
        });
        let state: BattleState = BattleState.Ongoing;
        while (state === BattleState.Ongoing) {
            state = battle.simulateRound();
            await int.channel?.send(battle.log);
        }
        switch (state) {
            case BattleState.Team1Win:
                return await int.channel?.send('gamer 1 wins');
            case BattleState.Team2Win:
                return await int.channel?.send('gamer 2 wins');
        }
	}
};
